"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const debounce = (func, wait = 1000, immediate = true) => {
    let timer = null;
    return function () {
        let context = this;
        let args = arguments;
        if (timer)
            clearTimeout(timer);
        if (immediate) {
            let callNow = !timer;
            timer = setTimeout(() => {
                timer = null;
            }, wait);
            if (callNow)
                func.apply(context, args);
        }
        else {
            timer = setTimeout(() => {
                func.apply(context, args);
            }, wait);
        }
    };
};
exports.default = debounce;
